ParticleFactory = Core.class(Sprite)
 
function ParticleFactory:init(config)
 
	self.conf = {
		autoStart = true,
		width = 7,
		height = 7,
		density = 100,
		particleColor = 0xAAAA00,
		alphaSpeed = 0.03,
		sizeSpeed = 0.03,
		sizeMin = 10,
		sizeMax = 19,
		rotationMin = 5 ,
		rotationMax = 10,
		speedMin = 10,
		speedMax = 200
	}
 
	if config then
		for key,value in pairs(config) do
			self.conf[key]= value
		end
	end
 
	self.count = self.conf.density * self.conf.height * self.conf.width * 0.002

	if self.conf.autoStart == true then
 
		self:createParticles()
 
	end
end
 
function ParticleFactory:createParticles()
 
	self.particles = Particles.new()
 
	local particles = {}
	
	for y=0,self.count do
		
		local angle = math.random()*math.pi*2;
		local length =  math.random();
		local xPos = math.cos(angle) * (self.conf.width/2) *length
		local yPos = math.sin(angle) * (self.conf.height/2) *length
 
		local speedX = (math.random(self.conf.speedMin,self.conf.speedMax) / 100) * (xPos/ math.abs(xPos)) 
		local speedY =  (math.random(self.conf.speedMin,self.conf.speedMax) / 100) * (yPos/ math.abs(yPos))
 
		--Todo speed config
		local particleConfig = 
		{
			x=xPos,
			y = yPos,
			size = math.random(self.conf.sizeMin*10,self.conf.sizeMax*10) / 10,
			decayAlpha = 0.96,
			speedX = speedX,
			ttl = 100,
			speedGrowth = -0.2,
			decayGrowth = .99,
			speedY = speedY,
			color = self.conf.particleColor
		}
		
		table.insert(particles,particleConfig)
	end
	
	self.particles:addParticles(particles)
	self:addChild(self.particles)
 
end
 
 
 
function ParticleFactory:getWidth()
	return self.conf.width
end
 
function ParticleFactory:getHeight()
	return self.conf.height
end